image: node:17-alpine

stages:
  - test
  - build
  - deploy

workflow:
  rules:
    - if: $CI_COMMIt_BRANCH != "main" && $CI_Pipeline_Source != "merge_request_event"
      when : never
    - when: always

variables:
  image_repository: docker.io/my-docker-id/myapp
  immage_tag: v1.0

run_lint_tests:
  stage: test
  before_script:
    - echo "Preparing test data..."
  script:
    - echo "Run lint tests..."
  after_script:
    - echo "Cleaning up temporary files..."

run_unit_tests:
  stage: test
  before_script:
    - echo "Preparing test data...1 "
    - echo "Preparing test data...2 "
    - echo "Preparing test data...3 "
  script:
    - echo "Run unit test for micro service $MICROSERVICE_NAME"
  after_script:
    - echo "Cleaning up temporary files..."

run_e2e_tests:
  stage: test
  before_script:
    - echo "Preparing test data..."
  script:
    - echo "Run unit tests..."
  after_script:
    - echo "Cleaning up temporary files..."


build_image:
  only:
    - main
  stage: build
  script:
    - echo "Building the docker image..."
    - echo "Tagging the docker image $image_repository:$immage_tag"

push_image:
  only:
    - main
  stage: build
  needs:
    - build_image 
  script:
    - echo "Logging into docker registry..."
    - echo "Pushing docker $image_repository:$immage_tag to registry..."

deploy_image:
  only:
    - main
  stage: deploy
  script:
    - echo "Deploying new docker image $image_repository:$immage_tag to $DEPLOYMENT_ENVIRONMENT using the following configuration file - $PROPERTIES_FILE ..."
    - cat $PROPERTIES_FILE

